<!DOCTYPE html>
<html <?php language_attributes(); ?>>
<head>
    <meta charset="UTF-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <?php wp_head(); ?>
</head>
<body <?php body_class(); ?>>
    <?php wp_body_open(); ?>

    <header>
        <img src="<?php header_image(); ?>" height="<?php echo get_custom_header()->height; ?>" width="<?php echo get_custom_header()->width; ?>" alt="" />
        <div class="container">
            <div class="header-identity">
                <div>
                    <?php if (has_custom_logo()) :
                        the_custom_logo();
                    else:
                        echo '<a href="' . esc_url(home_url('/')) . '"><h1>' . get_bloginfo('name') . '</h1></a>';
                    endif; ?>
                </div>
                <p><?php bloginfo('description'); ?></p>
            </div>
            <section class="menu-area">
                <div class="container">
                    <nav class="main-menu">
                        <button class="check-button">
                            <div class="menu-icon">
                                <div class="bar1"></div>
                                <div class="bar2"></div>
                                <div class="bar3"></div>
                            </div>
                        </button>
                        <?php
                            wp_nav_menu(array(
                                'theme_location' => 'primary',
                                'depth' => 2,
                                'fallback_cb' => 'nexa_default_menu'
                            ));
                        ?>
                    </nav>                    
                </div>
            </section>
            
        </div>
    </header>
